unit Rando;                            //698

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Propos, Grids, StdCtrls, Jpeg;

type
  TRand = class(TForm)
    MainMenu1: TMainMenu;
    Voyages1: TMenuItem;
    Enregistrer1: TMenuItem;
    Supprimer1: TMenuItem;
    Inserer1: TMenuItem;
    Basculer1: TMenuItem;
    Itinraire1: TMenuItem;
    N1: TMenuItem;
    APropos1: TMenuItem;
    Aides1: TMenuItem;
    Projet1: TMenuItem;
    Caractristiques1: TMenuItem;
    Poses1: TMenuItem;
    Marches1: TMenuItem;
    Velo1: TMenuItem;
    Transfert1: TMenuItem;
    Voiture1: TMenuItem;
    Ouvrir1: TMenuItem;
    Nouveau1: TMenuItem;
    N2: TMenuItem;
    Quitter2: TMenuItem;
    Mcrire1: TMenuItem;
    liste_iti: TStringGrid;
    liste_eta: TStringGrid;
    N3: TMenuItem;
    Cartes1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Routes1: TMenuItem;
    ImPrimmer1: TMenuItem;
    N4: TMenuItem;
    Gps1: TMenuItem;
    PrintDialog1: TPrintDialog;
    Propos1: TPropos;
    procedure Quitter2Click(Sender: TObject);
    procedure APropos1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Nouveau1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Enregistrer1Click(Sender: TObject);
    procedure liste_itiGetEditMask(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure Supprimer1Click(Sender: TObject);
    procedure Inserer1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Voiture1Click(Sender: TObject);
    procedure Itinraire1Click(Sender: TObject);
    procedure liste_etaGetEditMask(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure liste_etaSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Mcrire1Click(Sender: TObject);
    procedure Aides1Click(Sender: TObject);
    procedure Cartes1Click(Sender: TObject);
    procedure ImPrimmer1Click(Sender: TObject);
    procedure Routes1Click(Sender: TObject);
    procedure Gps1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Rand: TRand;

implementation

{$R *.DFM}

USES
  IniFiles, Randodec, Randopro, Randocar, ShellApi, Randopla,
    Randorte, Printers, FileCtrl;

PROCEDURE fermeture;
VAR
  f_init : TiniFile;
BEGIN
  F_Init := TiniFile.Create(nom_Rep+'Randi.rnd');
    F_Init.WriteString('Projet','Nom',ini_projet);
    F_Init.WriteInteger('Projet','Itinraire',0);
  F_Init.Free;
END;

procedure TRand.Quitter2Click(Sender: TObject);
begin
  fermeture;Application.Terminate;
end;

procedure TRand.APropos1Click(Sender: TObject);
begin
  Propos1.PCaption := 'A propos de l''diteur de feuilles de routes';
  Propos1.PVersion := ('5.05');
  Propos1.Lignes.Add('Version 1.91 : 1991');
  Propos1.Lignes.Add('  Editeur de feuilles de routes');
  Propos1.Lignes.Add('');
  Propos1.Lignes.Add('Version 2.92 : 1992');
  Propos1.Lignes.Add('  Calcul automatique des temps de marche');
  Propos1.Lignes.Add('');
  Propos1.Lignes.Add('Version 3.94 : 1994');
  Propos1.Lignes.Add('  Carractristiques de marche modifiables');
  Propos1.Lignes.Add('    Temps en vlo, voiture, ...');
   Propos1.Lignes.Add('');
  Propos1.Lignes.Add('Version 4.97 : 1997');
  Propos1.Lignes.Add('  Gestion des itinraires avec un rpertoire');
  Propos1.Lignes.Add('    pour chaque projet');
  Propos1.Lignes.Add('');
  Propos1.Lignes.Add('Version 5.00 : 2000');
  Propos1.Lignes.Add('  Intgration du routeur avec cartes scannes');
  Propos1.Lignes.Add('    en JPG');
  Propos1.Lignes.Add('');
  Propos1.Lignes.Add('Version 5.05 : 2005');
  Propos1.Lignes.Add('  Affichage de la cate fonction de l''cran ');
  Propos1.Lignes.Add('');
  propos1.Execute;
end;

procedure TRand.FormCreate(Sender: TObject);
VAR
  f_init : TiniFile;
begin
  nom_rep := ExtractFilePath(Application.ExeName);
  page := TRUE;
  F_Init := TiniFile.Create(nom_Rep+'Randi.rnd');
    ini_projet := F_Init.ReadString('Projet','Nom','');
    ini_iti := F_Init.ReadInteger('Projet','Itinraire',0);
  F_Init.Free;
  lecture_caracteristique;
  IF NOT(FileExists(nom_rep+ini_projet+'\'+'Randd.rnd'))
  THEN ini_projet := '';
  Rand.Caption := 'Editeur de route pour '+ini_projet;
  IF ini_projet=''
  THEN BEGIN
    Enregistrer1.Enabled := False;
    Supprimer1.Enabled := False;Inserer1.Enabled := False;
    Itinraire1.Enabled := False;liste_iti.Visible := FALSE;
    Cartes1.Enabled := FALSE;
  END
  ELSE lecture_donnees;
end;

procedure TRand.Nouveau1Click(Sender: TObject);
VAR
  lrep : String;
begin
  Randpro.Caption := 'Nouveau Projet';randpro.show;
end;

procedure TRand.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  fermeture;
end;

procedure TRand.Enregistrer1Click(Sender: TObject);
begin
  IF page
  THEN BEGIN
    IF MessageDlg('Mmorisation du catalogue ?',mtConfirmation,
                    [mbYes,mbNo],0)=mrYes
    THEN ecriture_donnees;
  END
  ELSE ecriture_itineraire(Liste_iti.Row);;
end;

procedure TRand.liste_itiGetEditMask(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
begin
  CASE Acol OF
    2:Value := '!90/90/90';
    3,4:Value := '90:90';
  END;
end;

procedure TRand.Supprimer1Click(Sender: TObject);
VAR
  nom_fichier,nouv_fichier : String;
  f_donnees                : t_f_don;
  i                        : Byte;
begin
  IF page
  THEN BEGIN
    IF MessageDlg('Voulez-vous rellement supprimer la ligne :'+#13+#13+
                    liste_iti.Cells[1,liste_iti.Row],mtConfirmation,
                    [mbYes,mbNo],0)=mrYes
    THEN BEGIN
      IF liste_iti.Row<49
      THEN FOR i:=liste_iti.Row TO 48 DO
        BEGIN
          nom_fichier := nom_rep+ini_projet+'\'+'rand'+
                         IntToStr(i)+'.rnd';
          nouv_fichier := nom_rep+ini_projet+'\'+'rand'+
                          IntToStr(i+1)+'.rnd';
          AssignFile(f_donnees,nom_fichier);
          TRY
            Erase(f_donnees);
          EXCEPT
          END;
          AssignFile(f_donnees,nouv_fichier);
          TRY
            Rename(f_donnees,nom_fichier);
          EXCEPT
          END;
          liste_iti.Rows[i] := liste_iti.Rows[i+1];
        END;
      nom_fichier := nom_rep+ini_projet+'\'+'rand'+
                     IntToStr(49)+'.rnd';
      AssignFile(f_donnees,nom_fichier);
      TRY
        Erase(f_donnees);
      EXCEPT
      END;
      FOR i:=0 TO 4 DO
        liste_iti.Cells[i,49] := '';
      ecriture_donnees;
    END;
  END
  ELSE BEGIN
    IF liste_eta.Row<50
    THEN FOR i:=liste_eta.Row TO 49 DO
        liste_eta.Rows[i] := liste_eta.Rows[i+1];
    FOR i:=0 TO 6 DO
      liste_eta.Cells[i,50] := '';
  END;
end;

procedure TRand.Inserer1Click(Sender: TObject);
VAR
  nom_fichier,nouv_fichier : String;
  f_donnees                : t_f_don;
  i                        : Byte;
begin
  IF page
  THEN BEGIN
    IF liste_iti.Row<49
    THEN FOR i:=49 DOWNTO liste_iti.Row+1 DO
      BEGIN
        nom_fichier := nom_rep+ini_projet+'\'+'rand'+
                       IntToStr(i)+'.rnd';
        nouv_fichier := nom_rep+ini_projet+'\'+'rand'+
                        IntToStr(i-1)+'.rnd';
        AssignFile(f_donnees,nom_fichier);
        TRY
          Erase(f_donnees);
        EXCEPT
        END;
        AssignFile(f_donnees,nouv_fichier);
        TRY
          Rename(f_donnees,nom_fichier);
        EXCEPT
        END;
        liste_iti.Rows[i] := liste_iti.Rows[i-1];
      END;
    nom_fichier := nom_rep+ini_projet+'\'+'rand'+
                   IntToStr(liste_iti.Row)+'.rnd';
    AssignFile(f_donnees,nom_fichier);
    TRY
      Erase(f_donnees);
    EXCEPT
    END;
    FOR i:=0 TO 4 DO
      liste_iti.Cells[i,liste_iti.Row] := '';
    ecriture_donnees;
  END
  ELSE BEGIN
    IF liste_eta.Row<50
    THEN FOR i:=50 DOWNTO liste_eta.Row+1 DO
        liste_eta.Rows[i] := liste_eta.Rows[i-1];
  END;
end;

procedure TRand.Ouvrir1Click(Sender: TObject);
VAR
  lrep : String;
begin
  lrep :='';
  IF SelectDirectory('Ouvrir un projet',nom_rep,lrep)
  THEN BEGIN
    ini_projet := extraire(lrep);
    Caption := 'Editeur de route pour '+ini_projet;
  END;
  IF ini_projet<>''
  THEN BEGIN
    lecture_donnees; cartes1.Enabled := TRUE;
    Enregistrer1.Enabled := TRUE;
    Supprimer1.Enabled := TRUE;Inserer1.Enabled := TRUE;
    Itinraire1.Enabled := TRUE;liste_iti.Visible := TRUE;
  END
  ELSE BEGIN
    Enregistrer1.Enabled := FALSE;
    Supprimer1.Enabled := FALSE;Inserer1.Enabled := FALSE;
    Itinraire1.Enabled := FALSE;liste_iti.Visible := FALSE;
    cartes1.Enabled := FALSE;
  END;
end;

procedure TRand.Voiture1Click(Sender: TObject);
begin
  Randcar.Caption := '';
  IF (sender=Voiture1)
  THEN Randcar.Caption := 'V';
  IF (sender=Transfert1)
  THEN Randcar.Caption := 'T';
  IF (sender=Velo1)
  THEN Randcar.Caption := 'O';
  IF (sender=Voiture1)
  THEN Randcar.Caption := 'V';
  IF (sender=Marches1)
  THEN Randcar.Caption := 'M';
  IF (sender=Poses1)
  THEN Randcar.Caption := 'P';
  IF Randcar.Caption<>''
  THEN Randcar.Show;
end;

procedure TRand.Itinraire1Click(Sender: TObject);
begin
  IF page
  THEN BEGIN
    WITH liste_iti DO
    BEGIN
      lecture_itineraire(Row);Align := alTop;TopRow := Row;
      LeftCol := 4;Height := 29;Enabled := FALSE;Col := 1;
    END;
    WITH liste_eta DO
    BEGIN
      Align := alClient;Top := 29;
      Visible := TRUE;Col := 0;Row := 1;Enabled := TRUE;
    END;
    Voyages1.Caption := 'I&tinraire';Itinraire1.Caption := 'Ca&talogue';
    Routes1.Enabled := TRUE;Imprimmer1.Enabled := TRUE;Gps1.Enabled := TRUE;
    Ouvrir1.Enabled := False; Nouveau1.Enabled := False;
  END
  ELSE BEGIN
    IF MessageDlg('Mmorisation de l''itinraire ?',mtConfirmation,
                    [mbYes,mbNo],0)=mrYes
    THEN BEGIN
      ecriture_itineraire(liste_iti.Row);ecriture_donnees;
    END;
    liste_iti.Align := alClient;
    Voyages1.Caption := 'Ca&talogue';Itinraire1.Caption := 'I&tinraire';
    liste_iti.Enabled := TRUE;liste_eta.Visible := FALSE;
    Routes1.Enabled := FALSE;Imprimmer1.Enabled := FALSE;GPS1.Enabled := FALSE;
    Ouvrir1.Enabled := TRUE; Nouveau1.Enabled := TRUE;
  END;
  page := NOT(page);
end;

procedure TRand.liste_etaGetEditMask(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
begin
  CASE ACol OF
    1:Value := '>Cc';
    2,4,5:Value := '999999;0';
    6:Value := '!90:00!';
  END;
end;

procedure TRand.liste_etaSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
VAR
  i        : Byte;
  c1,c2    : Char;
  distance : LongInt;
  deniv    : LongInt;
  temps    : TDateTime;
begin
  BEGIN
    IF liste_eta.Cells[0,1]<>''
    THEN liste_eta.Cells[6,1] := Liste_iti.Cells[3,liste_iti.Row];
    IF liste_eta.Cells[6,1]<>''
    THEN temps := StrToTime(liste_eta.Cells[6,1])
    ELSE temps := 0;
    FOR i:=2 TO 50 DO
    BEGIN
      IF liste_eta.Cells[1,i-1]=''
      THEN liste_eta.Cells[6,i] := ''
      ELSE BEGIN
        IF length(liste_eta.Cells[1,i-1])<>2
        THEN liste_eta.Cells[6,i] := liste_eta.Cells[6,i-1]
        ELSE BEGIN
          IF liste_eta.Cells[5,i-1]<>''
          THEN distance := StrToInt(liste_eta.Cells[5,i-1])
          ELSE distance := 0;
          IF liste_eta.Cells[4,i-1]<>''
          THEN deniv := StrToInt(liste_eta.Cells[4,i-1])
          ELSE deniv := 0;
          IF liste_eta.Cells[4,i]<>''
          THEN deniv := StrToInt(liste_eta.Cells[4,i]) - deniv
          ELSE deniv := - deniv;
          IF liste_eta.Cells[1,i-1][1]='M'
          THEN BEGIN
            IF deniv>0
            THEN BEGIN
              IF ((deniv/caract[4,1].vitesse)/24)>((distance/caract[4,2].vitesse)/24)
              THEN liste_eta.Cells[1,i-1] := 'MM'
              ELSE liste_eta.Cells[1,i-1] := 'MP';
            END
            ELSE BEGIN
              deniv := - deniv;
              IF ((deniv/caract[4,3].vitesse)/24)>((distance/caract[4,2].vitesse)/24)
              THEN liste_eta.Cells[1,i-1] := 'MD'
              ELSE liste_eta.Cells[1,i-1] := 'MP';
            END;
          END;
          c1 := liste_eta.Cells[1,i-1][1];
          c2 := liste_eta.Cells[1,i-1][2];
          CASE liste_eta.Cells[1,i-1][1] OF
            'V':CASE c2 OF
              'A':BEGIN
                temps := ((distance/caract[1,1].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'N':BEGIN
                temps := ((distance/caract[1,2].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'D':BEGIN
                temps := ((distance/caract[1,3].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              ELSE liste_eta.Cells[6,i] := liste_eta.Cells[6,i-1];
            END;
            'T':CASE c2 OF
              'N':BEGIN
                temps := ((distance/caract[2,1].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'D':BEGIN
                temps := ((distance/caract[2,2].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'F':BEGIN
                temps := ((distance/caract[2,3].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              ELSE liste_eta.Cells[6,i] := liste_eta.Cells[6,i-1];
            END;
            'O':CASE c2 OF
              'M':BEGIN
                temps := ((distance/caract[3,1].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'P':BEGIN
                temps := ((distance/caract[3,2].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'D':BEGIN
                temps := ((distance/caract[3,3].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              ELSE liste_eta.Cells[6,i] := liste_eta.Cells[6,i-1];
            END;
            'M':CASE c2 OF
              'M':BEGIN
                temps := ((deniv/caract[4,1].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'P':BEGIN
                temps := ((distance/caract[4,2].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'D':BEGIN
                temps := ((deniv/caract[4,3].vitesse)/24) + temps;
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              ELSE liste_eta.Cells[6,i] := liste_eta.Cells[6,i-1];
            END;
            'P':CASE c2 OF
              'A':BEGIN
                temps := temps + ((caract[5,1].vitesse/24)/60);
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'C':BEGIN
                temps := temps + ((caract[5,2].vitesse/24)/60);
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              'R':BEGIN
                temps := temps +((caract[5,3].vitesse/24)/60);
                liste_eta.Cells[6,i] := COPY(TimeToStr(temps),1,5);
              END;
              ELSE liste_eta.Cells[6,i] := liste_eta.Cells[6,i-1];
            END;
            ELSE liste_eta.Cells[6,i] := liste_eta.Cells[6,i-1];
          END;
        END;
        IF liste_eta.Cells[6,i]<>''
        THEN liste_iti.Cells[4,liste_iti.Row]:= liste_eta.Cells[6,i];
      END;
    END;
  END;
end;

procedure TRand.Mcrire1Click(Sender: TObject);
begin
  IF 42<>ShellExecute (Application.Handle,'Open',
                       'mailto:boquillion@wanadoo.fr?subject=Randonnes',
                       Nil,Nil,SW_SHOW)
  THEN MessageDlg('Le courier lectronique par dfaut'+#13+#13+
                  'n''est pas install correctement',
                   mtWarning, [mbYes], 0)
end;

procedure TRand.Aides1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS,0);
end;

procedure TRand.Cartes1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := nom_rep+ini_projet;
  OpenDialog1.Filter := 'Fichier Carte |*.JPG';
  IF OpenDialog1.Execute
  THEN BEGIN
     Randpla.Caption := OpenDialog1.FileName;
     Randpla.Show;
  END;
end;

procedure TRand.ImPrimmer1Click(Sender: TObject);
VAR
  i,grand,j                :Integer;
  mont,desc,plat,voit,velo :Integer;
  lig,decal                :integer;
  c1,c2                    :string;
  CoefLarg,CoefHaut        :Real;
  FUNCTION MetLarg(lL : Longword): Longword;   // en 10me de mm
  BEGIN
    MetLarg := ROUND(lL* CoefLarg);
  END;
  FUNCTION MetHaut(lH : LongWord): LongWord;  // en 10me de mm
  BEGIN
    MetHaut := Round(lH * CoefHaut);
  END;
 {Imprimable x[30,2400] ; y[0,3319]; u = dist*300/25.4}
begin
  c1 := Liste_iti.cells[1,Liste_iti.Row];c2 := Liste_iti.cells[2,Liste_iti.Row];
  mont := 0;desc := 0;plat := 0;voit := 0;velo := 0;grand := 50;i := 0;
  While ((grand>0) AND (Liste_eta.cells[0,grand]='')) DO
    Dec(grand);
  IF (MessageDlg('Impression de l''itinraire ?',mtConfirmation,[mbYes,mbNo],0)= mrYes)
        AND PrintDialog1.Execute
  THEN BEGIN
    Printer.Orientation:=poPortrait;
    Printer.Title := 'Route de '+c1;
    Printer.BeginDoc;
    With Printer.Canvas do
    begin
      CoefLarg := Printer.PageWidth / 2000;   // marge gauche et droite de 5 mm
      CoefHaut := Printer.PageHeight/ 2800;   //       haut 1 et bas 16 mm
      Font.name:='Arial';decal:=MetHaut(50);
      Font.Size := 24;Pen.Color := clBlue;Pen.Width := 2;Pen.style := psSolid;
      Font.Color := clBlue;
      TextOut(MetLarg(917)-((TextWidth(c1)div 2)),
              MetHaut(167)-TextHeight(c1),c1);
      Font.Size:=18;Font.Color := clBlack;
      TextOut(MetLarg(1918)-TextWidth(c2),MetHaut(167)-TextHeight(c2),c2);
      lig:=MetHaut(167)+decal;
      While i<grand DO
      BEGIN
        INC(i);
        IF (i MOD 26 = 0)
        THEN BEGIN
          lig := MetHaut(167);Printer.NewPage;
        END;
        Font.Size:=16;Inc(lig,decal);c1 := Liste_eta.cells[0,i];
        IF c1<>''
        THEN BEGIN
          MoveTo(MetLarg(83),lig-MetHaut(12));LineTO(MetLarg(1835),lig-MetHaut(12));
        END;
        Font.Color := clBlack;TextOut(MetLarg(50),lig-TextHeight(c1),c1);
        Font.Size:=10;c2 := Liste_eta.cells[3,i];
        Font.Color := clRed;
        TextOut(MetLarg(917)-((TextWidth(c2))DIV 2),lig-TextHeight(c2),c2);
        IF Liste_eta.cells[4,i]<>''
        THEN c1 := Liste_eta.cells[4,i]+' m'
        ELSE c1 := '';
        Font.Size:=12;
        TextOut(MetLarg(1585)-(TextWidth(c1)),lig-TextHeight(c1),c1);
        Font.Size:=16;
        IF Liste_eta.cells[6,i]<>''
        THEN c1 := Liste_eta.cells[6,i]+ ' H'
        ELSE c1 := '';
        Font.Color := clBlack;
        TextOut(MetLarg(1918)-(TextWidth(c1)),lig-TextHeight(c1),c1);
        Font.size:=14;Inc(lig,decal);Font.Color := clBlue;
        IF Liste_eta.cells[1,i]<>''
        THEN BEGIN
          c2 := Copy(Liste_eta.cells[1,i]+' '+Liste_eta.cells[2,i],2,20);
          IF (Liste_eta.cells[1,i][1]='M') OR (Liste_eta.cells[1,i][1]='O')
          THEN Font.Color := clGreen;
          IF (Liste_eta.cells[1,i][1]='P')
          THEN Font.Color := clRed;
        END
        ELSE c2 := '';
        TextOut(MetLarg(584),lig-TextHeight(c2),c2);
        IF Liste_eta.cells[5,i]<>''
        THEN BEGIN
          IF Liste_eta.cells[1,i][1]='M'
          THEN c1 := Liste_eta.cells[5,i] + ' m'
          ELSE C1 := Liste_eta.cells[5,i] + ' Km';
        END
        ELSE c1 := '';
        TextOut(MetLarg(1334)-(TextWidth(c1)),lig-TextHeight(c1),c1);
        IF (i>1) AND (Liste_eta.cells[1,i-1]<>'')
        THEN CASE Liste_eta.cells[1,i-1][1] OF
            'V','T':IF Liste_eta.cells[5,i-1]<>''
              THEN voit := voit + StrToInt(Liste_eta.cells[5,i-1]);
            'O':IF Liste_eta.cells[5,i-1]<>''
              THEN velo := velo + StrToInt(Liste_eta.cells[5,i-1]);
            'M':BEGIN
              IF ((Liste_eta.Cells[4,i-1]<>'') AND (Liste_eta.Cells[4,i]<>''))
              THEN IF StrToInt(Liste_eta.cells[4,i])>StrToInt(Liste_eta.cells[4,i-1])
                THEN mont := mont + StrToInt(Liste_eta.cells[4,i]) - StrToInt(Liste_eta.cells[4,i-1])
                ELSE desc := desc - StrToInt(Liste_eta.cells[4,i]) + StrToInt(Liste_eta.cells[4,i-1]);
              IF Liste_eta.cells[5,i-1]<>''
              THEN plat := plat + StrToInt(Liste_eta.cells[5,i-1]);
            END;
          END;
      END;
      Font.Color := clBlack;
      IF voit>0
      THEN BEGIN
        INC(i);
        IF (i MOD 26 = 0)
        THEN BEGIN
          Printer.NewPage;lig := MetHaut(100);
        END;
        Inc(lig,decal);c2 := 'Kilomtrage en Voiture : '+IntToStr(voit)+' Km';
        TextOut(MetLarg(50),lig-TextHeight(c2),c2);
      END;
      IF velo>0
      THEN BEGIN
        INC(i);
        IF (i MOD 26 = 0)
        THEN BEGIN
          Printer.NewPage;lig := MetHaut(100);
        END;
        Inc(lig,decal);c2 := 'Kilomtrage en Vlo : '+IntToStr(velo)+' Km';
        TextOut(MetLarg(50),lig-TextHeight(c2),c2);
      END;
      IF plat>0
      THEN BEGIN
        INC(i);
        IF (i MOD 26 = 0)
        THEN BEGIN
          Printer.NewPage;lig := MetHaut(100);
        END;
        Inc(lig,decal);c2 := 'Distance  pied parcourue : '+IntToStr(plat)+' m';
        TextOut(MetLarg(50),lig-TextHeight(c2),c2);
      END;
      IF mont>0
      THEN BEGIN
        INC(i);
        IF (i MOD 26 = 0)
        THEN BEGIN
          Printer.NewPage;lig := MetHaut(100);
        END;
        Inc(lig,decal);c2 := 'Dnivele cumule : '+IntToStr(mont)+' m';
        TextOut(MetLarg(50),lig-TextHeight(c2),c2);
      END;
      IF desc>0
      THEN BEGIN
        INC(i);
        IF (i MOD 26 = 0)
        THEN BEGIN
          Printer.NewPage;lig := MetHaut(100);
        END;
        Inc(lig,decal);c2 := 'Descente : '+IntToStr(desc)+' m';
        TextOut(MetLarg(50),lig-TextHeight(c2),c2);
      END;
    END;
    Printer.EndDoc;
  END;
end;

procedure TRand.Routes1Click(Sender: TObject);
begin
  RandRte.Caption := 'Insre une route  partir de la ligne '+
                      IntToStr(liste_eta.Row);
  Randrte.show;
end;

procedure TRand.Gps1Click(Sender: TObject);
begin
   RandRte.Caption := 'Cre un fichier GPS de la route ';
   Randrte.show;
end;

end.
