unit Randocar;               // 96

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask;

type
  TRandcar = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    MaskEdit1: TMaskEdit;
    MaskEdit2: TMaskEdit;
    MaskEdit3: TMaskEdit;
    Memoriser: TButton;
    procedure FormActivate(Sender: TObject);
    procedure MaskEdit1Change(Sender: TObject);
    procedure MemoriserClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Randcar: TRandcar;

implementation

{$R *.DFM}

USES
  Randodec;

VAR
  num_car     : Byte;

procedure TRandcar.FormActivate(Sender: TObject);
begin
  WITH Randcar DO
  BEGIN
    CASE caption[1] OF
      'V':BEGIN
        num_car := 1;label4.caption := 'Vitesses en Km/h';
        Caption := 'Caractristiques pour Voiture sur Routes de plaine';
      END;
      'T':BEGIN
        num_car := 2;label4.caption := 'Vitesses en Km/h';
        Caption := 'Caractristiques pour Voiture sur routes de montagne';
      END;
      'O':BEGIN
        num_car := 3;label4.caption := 'Vitesses en Km/h';
        Caption := 'Caractristiques pour vlo';
      END;
      'M':BEGIN
        num_car := 4;label4.caption := 'Dniveles en m/h';
        Caption := 'Caractristiques des temps de Marche';
      END;
      'P':BEGIN
        num_car := 5; label4.caption := 'Temps en minutes';
        Caption := 'Personnalisation des temps de Poses';
      END;
    END;
    label1.caption := caract[num_car,1].Nature;
    label2.caption := caract[num_car,2].Nature;
    label3.caption := caract[num_car,3].Nature;
    MaskEdit1.Text := IntToStr(caract[num_car,1].Vitesse);
    MaskEdit2.Text := IntToStr(caract[num_car,2].Vitesse);
    MaskEdit3.Text := IntToStr(caract[num_car,3].Vitesse);
    Memoriser.Enabled := FALSE;
  END;
end;

procedure TRandcar.MaskEdit1Change(Sender: TObject);
begin
  memoriser.Enabled := ( (MaskEdit1.Text<>'') AND
                         (MaskEdit2.Text<>'') AND
                         (MaskEdit3.Text<>''));
end;

procedure TRandcar.MemoriserClick(Sender: TObject);
begin
  WITH Randcar DO
  BEGIN
    caract[num_car,1].Vitesse := StrToInt(MaskEdit1.Text);
    caract[num_car,2].Vitesse := StrToInt(MaskEdit2.Text);
    caract[num_car,3].Vitesse := StrToInt(MaskEdit3.Text);
    Hide;
  END;
  ecriture_caracteristique;
end;

end.
